const fs = require('fs');

const dsTypes = ["manual", "editor", "position"]

const projectId_0 = "Company-Internal"
const projectId_0_Lunch = "Lunch" 
const projectId_0_Meeting = "Meeting"


const projectId_1 = "projectId_1"
const p1_taskId_1 = "p1_taskId_1"
const p1_taskId_2 = "p1_taskId_2"

const projectId_2 = "projectId_2"
const p2_taskId_1 = "p2_taskId_1"

const EIGHT_O_CLOCK = 1561701600;
const LUNCH_TIME_START = 1561712600;
const LUNCH_TIME_END = 1561719800;
const DELAY_FROM_WORK = 1500;

const NINE_MIN_IN_MSEC = 540;
const EIGHT_HOUR_IN_MSEC = 28800;
const collectedData = [];

const userData1 = {
    userEmail: "user1@email.com",
    projectId: projectId_1,
    taskId: p1_taskId_1,
    datasourceType: '',
    createdAt: '',
}

const userData2 = {
    userEmail: "user2@email.com",
    projectId: projectId_1,
    taskId: p1_taskId_2,
    datasourceType: '',
    createdAt: ''
}

const userData3 = {
    userEmail: "user3@email.com",
    projectId: projectId_2,
    taskId: p2_taskId_1,
    datasourceType: '',
    createdAt: '',
}

function getReadableDate(time) {
    var date = new Date(time * 1000);
    var hours = date.getHours();
    var minutes = "0" + date.getMinutes();
    var seconds = "0" + date.getSeconds();
    return hours + ':' + minutes.substr(-2) + ':' + seconds.substr(-2);
}

function getRandomInt(max) {
    return Math.floor(Math.random() * Math.floor(max));
  }

for (worktime = 0; worktime < EIGHT_HOUR_IN_MSEC; worktime += NINE_MIN_IN_MSEC) {
    const time = EIGHT_O_CLOCK + worktime;
    const user1 = Object.assign({}, userData1);
    const user2 = Object.assign({}, userData2);
    const user3 = Object.assign({}, userData3);
    const userStorage = [];
    
    // User 1 ebédidő végéig van csak irodában.
    if (time < LUNCH_TIME_END) {
        user1.createdAt = time;
        user1.datasourceType = dsTypes[1];
        userStorage.push(user1); 
    }

    // User 2 fixen dolgozik, viszont kivesz egy jó hosszú ebédidőt.
    
    if (time > LUNCH_TIME_START && time < LUNCH_TIME_END) {
        user2.projectId=projectId_0;
        user2.datasourceType = dsTypes[2];
        user2.taskId=projectId_0_Lunch;
        user2.createdAt = time;
        userStorage.push(user2);
    } else {
        user2.projectId=projectId_1;
        user2.datasourceType = dsTypes[1];
        user2.taskId=p1_taskId_2;
        user2.createdAt = time;
        userStorage.push(user2);
    }
    
    

    // User 3 elkésik a munkából és sok ismeretlen ideje van.
    if (time > EIGHT_O_CLOCK + DELAY_FROM_WORK) {
        user3.createdAt = time;
        user3.datasourceType = dsTypes[1];
        userStorage.push(user3);
    }
    
    if ( getRandomInt(50) < 20) {
        userStorage.pop();
    }



    userStorage.forEach(element => {
        collectedData.push(element)
    });
}

fs.writeFileSync('data.json', JSON.stringify(collectedData));